
// Array.h: interface for the Array class.

#if !defined(ARRAY_INCLUDED)
#define ARRAY_INCLUDED
#if defined _debug
   static bool DEBUG = true;
#else
   static bool DEBUG = false;
#endif
#include <stdio.h>

class Array2D{
public:
   Array2D();
   Array2D(int nn0, int nn1);
   virtual ~Array2D();
   void ArraySet(int nn0, int nn1);
   void ArrayChk(const char *Aname);
   int LUSolveA(double *b);
   int LUFactr();
   int LUSubst(double *b);
   int n0;  // rows
   int n1;  // columns
   double **v;  // 2d array, i.e. pointer to array of pointers
private:
   int *ipiv;
   void Allocate();
   void Deallocate();
};
void dgedi ( double a[], int lda, int n, int ipvt[], double det[],double work[], int job );
int dgefa ( double a[], int lda, int n, int ipvt[] );
void dgesl ( double a[], int lda, int n, int ipvt[], double b[], int job );
void daxpy ( int n, double da, double dx[], int incx, double dy[], int incy );
double ddot ( int n, double dx[], int incx, double dy[], int incy );
void dscal ( int n, double sa, double x[], int incx );
void dswap ( int n, double x[], int incx, double y[], int incy );
int idamax ( int n, double dx[], int incx );
double r8_abs ( double x );

#endif // !defined(ARRAY_INCLUDED)
