#if !defined(BVP_INCLUDED)
#define BVP_INCLUDED

#include "Array.h"
class SolveBVP  
{
public:
	SolveBVP(){}
	virtual ~SolveBVP(){}
	void Solve(int nt);
private:
   int n;
	double Thx;
	double *xc; // collocation points
	double *wc; // quadrature weights
   Array2D Ac; // first derivative operator
   Array2D Bc; // 2nd derivative operator
   Array2D Cc; // symmetric 2nd derivative operator
   Array2D Dc; // mass matrix
   Array2D Lc; // interpolating polynomial
   void OCC_Solve(Array2D &A, Array2D &Aa, double *r, double *y);
   void OCC_Sym_Solve(Array2D &A, Array2D &Aa, double *r, double *y);
   void MM_interp_Solve(Array2D &A, Array2D &Aa, double rc[], double yc[]);
   void MM_Full_Solve(Array2D &A, Array2D &Am, double yc[]);
   void OCC_MM_Solve(Array2D &A, Array2D &Aa);
   void MMatrix(Array2D &D);
   void FluxCalc(int meth, double flux[], double yc[], double rc[], double wc[], Array2D &A, Array2D &Ac);
   void Interp_y(double yc[], double yi[], int ni, Array2D &L);
	void FuncRX(double *x, double *r, int n);
   void CopyAA(Array2D &A, Array2D &Aa, double *y);
	void ReportBasic();
   void ReportSolution(Array2D &yc, Array2D &yi, Array2D &flux);
};
#endif // !defined(BVP_INCLUDED)

